#include <stdio.h>
#include <stdlib.h>

#define maxc 150
typedef unsigned char *num;

num *L, *A;
num R;

int N;

void copy(num a, num b)
{
int i;
for (i = 0; i <= b[0]; i++)
a[i] = b[i];
for (i = b[0]+1; i < maxc; i++)
a[i] = 0;
}

void add(num r, num a)
{
int i;
if (a[0] > r[0]) r[0] = a[0];
r[0]++;
for (i = 1; i <= r[0]; i++)
{
r[i+1] += (r[i] + a[i]) / 10;
r[i] = (r[i] + a[i]) % 10;
}
for (; r[r[0]] == 0 && r[0] > 0; r[0]--);
}

void solve()
{
int i, j, s;
unsigned char * * t;

L = (num *) calloc(N+2, sizeof(*L));
A = (num *) calloc(N+2, sizeof(*A));

for (i = 0; i <= N+1; i++)
{
L[i] = (num) calloc(maxc+1, sizeof(char));
A[i] = (num) calloc(maxc+1, sizeof(char));
}

R = (num) calloc(maxc+1, sizeof(char));

L[1][0] = 1;
L[1][1] = 1;
for (i = 2; i <= N; i++)
{
if (i % 2 == 0)
for (j = 1; j <= i; j++)
{
copy(A[j], A[j-1]);
add(A[j], L[j-1]);
}
else
for (j = i; j > 0; j--)
{
copy(A[j], A[j+1]);
add(A[j], L[j]);
}
t = L;
L = A;
A = t;
}
copy(R, L[0]);
for (i = 1; i <= N; i++)
add(R, L[i]);
}

void print()
{
FILE *fo = fopen("PERM.OUT", "wt");
int i;
for (i = R[0]; i > 0; i--)
fprintf(fo, "%d", R[i]);
fprintf(fo, "\n");
fclose(fo);
}


void read_data()
{
FILE *fi = fopen("PERM.IN", "rt");
fscanf(fi, "%d", &N);
fclose(fi);
}

void main()
{
read_data();
solve();
print();
} 