Program Permutari_in_ZIGZAG;

const filein='perm.in';
      fileout='perm.out';
      MAXN=100;
      MAXC=150;
      avans=3;

type NMARE=array[0..MAXC] of integer;
     pNMARE=^NMARE;

var i,j,k,m,n:integer;
    nperm:array[0..MAXN] of pNMARE;
    comb:array[-1..MAXN,-1..MAXN] of pNMARE;
    naux,naux2:NMARE;

procedure aduna(n1,n2,rez:pNMARE);
var nci,co:integer;
begin
if (n1^[0]>n2^[0]) then
  nci:=n1^[0]
else
  nci:=n2^[0];

for co:=1 to nci+avans do
  begin
    rez^[co]:=rez^[co]+n1^[co]+n2^[co];
    if (rez^[co]>9) then
      begin
        rez^[co+1]:=rez^[co] div 10;
        rez^[co]:=rez^[co] mod 10;
      end;
  end;

for co:=nci+avans downto 1 do
  if (rez^[co]>0) then
    begin
      rez^[0]:=co;
      break;
    end;
end;

procedure inmul(n1,n2,rez:pNMARE);
var nci,co,ii,jj:integer;
begin
for ii:=1 to n1^[0] do
  for jj:=1 to n2^[0] do
    rez^[ii+jj-1]:=rez^[ii+jj-1]+n1^[ii]*n2^[jj];

nci:=n1^[0]+n2^[0]+avans;
for co:=1 to nci do
  if (rez^[co]>9) then
    begin
      rez^[co+1]:=rez^[co+1]+(rez^[co] div 10);
      rez^[co]:=rez^[co] mod 10;
    end;

for co:=nci downto 1 do
  if (rez^[co]>0) then
    begin
      rez^[0]:=co;
      break;
    end;
end;

begin
assign(input,filein);
reset(input);
readln(n);
close(input);

new(nperm[0]);
fillchar(nperm[0]^,sizeof(NMARE),0);
nperm[0]^[0]:=1; nperm[0]^[1]:=1;

new(nperm[1]);
fillchar(nperm[1]^,sizeof(NMARE),0);
nperm[1]^[0]:=1; nperm[1]^[1]:=1;

for i:=-1 to 1 do
  begin
    new(comb[0,i]);
    fillchar(comb[0,i]^,sizeof(NMARE),0);
  end;

comb[0,0]^[0]:=1; comb[0,0]^[1]:=1;

for i:=2 to n do
  begin
    { Calculeaza COMB[i-1] }
    new(comb[i-1,-1]);
    fillchar(comb[i-1,-1]^,sizeof(NMARE),0);

    for j:=0 to i-1 do
      begin
        new(comb[i-1,j]);

        fillchar(naux,sizeof(naux),0);
        aduna(comb[i-2,j-1],comb[i-2,j],@naux);
        move(naux,comb[i-1,j]^,sizeof(NMARE));
      end;

    new(comb[i-1,i]);
    fillchar(comb[i-1,i]^,sizeof(NMARE),0);

    for j:=-1 to i-1 do
      dispose(comb[i-2,j]);

    { Calculeaza NPERM[i] }
    new(nperm[i]);
    fillchar(nperm[i]^,sizeof(NMARE),0);

    for j:=0 to i-1 do
      if (j and 1=1) then
        begin
          fillchar(naux,sizeof(NMARE),0);
          inmul(nperm[j],nperm[i-j-1],@naux);

          fillchar(naux2,sizeof(NMARE),0);
          inmul(@naux,comb[i-1,j],@naux2);

          fillchar(naux,sizeof(NMARE),0);
          aduna(nperm[i],@naux2,@naux);

          move(naux,nperm[i]^,sizeof(NMARE));
        end;
  end;


assign(output,fileout);
rewrite(output);

for i:=nperm[n]^[0] downto 1 do
  write(nperm[n]^[i]);

writeln;
close(output);
end.