#include<stdio.h>
#include<alloc.h>
#include<mem.h>

#define FIN "pavare.in"
#define FOUT "pavare.out"
#define BUF_SZ 0xF000L
#define LIN_SZ 0x2800L
#define C0IMIN i
#define C0IMAX i+m-1
#define C0JMIN j+m
#define C0JMAX j+n-1
#define C1IMIN i
#define C1IMAX i+m-1
#define C1JMIN j
#define C1JMAX j+m-1
#define C2IMIN i+m
#define C2IMAX i+n-1
#define C2JMIN j
#define C2JMAX j+m-1
#define C3IMIN i+m
#define C3IMAX i+n-1
#define C3JMIN j+m
#define C3JMAX j+n-1
#define INCADR(x,y,t) C##t##IMIN<=x && x<=C##t##IMAX && \
                      C##t##JMIN<=y && y<=C##t##JMAX
#define VTLEFT ((i)?tab[t][l][i-1]:254)
#define VTLEFTA ((i)?a[l][i-1]:254)
#define VTUP ((l)?tab[t][l-1][i]:254)
#define VTUPA ((l)?a[l-1][i]:254)
#define VVLEFT (cur[i-1])
#define VVUP (val[ndx][i])

char tab[4][8][8]=
{
	{
		{9,   9,   8,   8,   4,   4,   3,   0},
  		{9,   7,   7,   8,   4,   2,   3,   3},
 		{10,   7,  11,  11,   5,   2,   2,  6},
 		{10,  10,  11,   1,   5,   5,   6,  6},
 		{14,  14,  13,   1,   1,  19,  18, 18},
 		{14,  12,  13,  13,  19,  19,  17, 18},
 		{15,  12,  12,  16,  20,  17,  17, 21},
 		{15,  15,  16,  16,  20,  20,  21, 21}
	},
	{
  		{0,   9,   8,   8,   4,   4,   3,   3},
  		{9,   9,   7,   8,   4,   2,   2,   3},
 		{10,   7,   7,  11,   5,   5,   2,  6},
 		{10,  10,  11,  11,   1,   5,   6,  6},
 		{14,  14,  13,   1,   1,  19,  18, 18},
 		{14,  12,  13,  13,  19,  19,  17, 18},
	 	{15,  12,  12,  16,  20,  17,  17, 21},
 		{15,  15,  16,  16,  20,  20,  21, 21}
   },
   {
   	{9,   9,   8,   8,   4,   4,   3,   3},
  		{9,   7,   7,   8,   4,   2,   2,   3},
 		{10,   7,  11,  11,   5,   5,   2,  6},
 		{10,  10,  11,   1,   1,   5,   6,  6},
 		{14,  14,  13,  13,   1,  19,  18, 18},
 		{14,  12,  12,  13,  19,  19,  17, 18},
 		{15,  15,  12,  16,  20,  17,  17, 21},
  		{0,  15,  16,  16,  20,  20,  21,  21}
	},
   {
   	{9,   9,   8,   8,   4,   4,   3,   3},
  		{9,   7,   7,   8,   4,   2,   2,   3},
 		{10,   7,  11,  11,   5,   5,   2,  6},
 		{10,  10,  11,   1,   1,   5,   6,  6},
 		{14,  14,  13,   1,  19,  19,  18, 18},
  		{14,  12,  13,  13,  19,  17,  17, 18},
 		{15,  12,  12,  16,  20,  17,  21, 21},
 		{15,  15,  16,  16,  20,  20,  21,  0}
	}
};

FILE* f;
char a[8][8],far* buf;
signed char tip[128][128];
int N,Lin,Col;
long buf_sz,lin_sz,cnt,ccnt,val[128][8],cur[8];
int gol[128][128];

void putpiece(int i,int j,int t)
{
	ccnt++;
   switch(t)
   	{
      	case 0:a[i][j]=a[i][j+1]=a[i+1][j]=ccnt;break;
         case 1:a[i][j]=a[i][j+1]=a[i+1][j+1]=ccnt;break;
         case 2:a[i][j]=a[i+1][j]=a[i+1][j+1]=ccnt;break;
         case 3:a[i][j+1]=a[i+1][j]=a[i+1][j+1]=ccnt;
      }
}

void pavare(int i,int j,int n,int l,int c)
{
	int m=n>>1,cadr;

   if(INCADR(l,c,0))cadr=0;
   if(INCADR(l,c,1))cadr=1;
   if(INCADR(l,c,2))cadr=2;
   if(INCADR(l,c,3))cadr=3;

   switch(cadr)
   	{
      	case 0:
        		if(n==2){putpiece(i,j,2);break;}
           	putpiece(C1IMAX,C1JMAX,2);
            pavare(C0IMIN,C0JMIN,m,l,c);
            pavare(C1IMIN,C1JMIN,m,C1IMAX,C1JMAX);
            pavare(C2IMIN,C2JMIN,m,C2IMIN,C2JMAX);
            pavare(C3IMIN,C3JMIN,m,C3IMIN,C3JMIN);
            break;
         case 1:
            if(n==2){putpiece(i,j,3);break;}
            putpiece(C1IMAX,C1JMAX,3);
            pavare(C0IMIN,C0JMIN,m,C0IMAX,C0JMIN);
            pavare(C1IMIN,C1JMIN,m,l,c);
            pavare(C2IMIN,C2JMIN,m,C2IMIN,C2JMAX);
            pavare(C3IMIN,C3JMIN,m,C3IMIN,C3JMIN);
            break;
         case 2:
            if(n==2){putpiece(i,j,1);break;}
            putpiece(C1IMAX,C1JMAX,1);
            pavare(C0IMIN,C0JMIN,m,C0IMAX,C0JMIN);
            pavare(C1IMIN,C1JMIN,m,C1IMAX,C1JMAX);
            pavare(C2IMIN,C2JMIN,m,l,c);
            pavare(C3IMIN,C3JMIN,m,C3IMIN,C3JMIN);
            break;
         case 3:
            if(n==2){putpiece(i,j,0);break;}
            putpiece(C1IMAX,C1JMAX,0);
            pavare(C0IMIN,C0JMIN,m,C0IMAX,C0JMIN);
            pavare(C1IMIN,C1JMIN,m,C1IMAX,C1JMAX);
            pavare(C2IMIN,C2JMIN,m,C2IMIN,C2JMAX);
            pavare(C3IMIN,C3JMIN,m,l,c);
      }
}

void flush(void);

void put(long n)
{
	int l;
   if(buf_sz>BUF_SZ-15)flush();
   l=sprintf(buf+buf_sz,"%ld ",n);
   buf_sz+=l;
}

void print_line(int t,int l,int lndx,int ndx) //indecsi in gol
{
	int i;long color;
   for(i=0;i<8;i++)
   	{
      	if(!tab[t][l][i]){put(cur[i]=gol[lndx][ndx]);continue;}
      	color=-1;
         if(l && tab[t][l][i]==tab[t][l-1][i+1])color=val[ndx][i+1];
         else
         	{
	      		if(tab[t][l][i]==VTUP)color=VVUP;
   	   	  	if(tab[t][l][i]==VTLEFT)color=VVLEFT;
            }
      	if(color==-1)color=++cnt;
         put(cur[i]=color);
      }
	memcpy(val[ndx],cur,sizeof(cur));
}

void print_mat(int l,int lndx,int ndx) //indecsi in gol
{
	int i;long color;
   for(i=0;i<8;i++)
   	{
      	if(!a[l][i]){put(cur[i]=gol[lndx][ndx]);continue;}
      	color=-1;
         if(l && a[l][i]==a[l-1][i+1])color=val[ndx][i+1];
         else
         	{
			    	if(a[l][i]==VTUPA)color=VVUP;
					if(a[l][i]==VTLEFTA)color=VVLEFT;
            }
         if(color==-1)color=++cnt;
         put(cur[i]=color);
      }
	memcpy(val[ndx],cur,sizeof(cur));
}

void putn(void)
{
   int l;
   if(buf_sz>BUF_SZ-15)flush();
   l=sprintf(buf+buf_sz,"\n");
   buf_sz+=l;
}

void flush(void)
{
	fwrite(buf,buf_sz,1,f);
   buf_sz=0;buf[0]=NULL;
}

void solve(void)
{
   int i,j,k,pavat=0;
   for(i=0;i<N>>3;i++)
   {
   	memset(val,0,sizeof(val));
   	for(j=0;j<8;j++)
      	{
	      	for(k=0;k<N>>3;k++)
            	if(tip[i][k]==0 || tip[i][k]==1 || tip[i][k]==2 || tip[i][k]==3)
   	         	print_line(tip[i][k],j,i,k);
  			      else
               	{
		            	if(!pavat)
								{
									pavare(0,0,8,Lin-(i<<3),Col-(k<<3));
									pavat=1;
								}
      		         print_mat(j,i,k);
             		}
            putn();
      	}
   }
}

void make_tip(int i,int j,int n,int l,int c)
{
	int m=n>>1,cadr;

   if(INCADR(l,c,0))cadr=0;
   if(INCADR(l,c,1))cadr=1;
   if(INCADR(l,c,2))cadr=2;
   if(INCADR(l,c,3))cadr=3;

   switch(cadr)
   	{
      	case 0:
            if(n==8)
					{
                  if(l==Lin && c==Col)tip[i>>3][j>>3]=255;
						else tip[i>>3][j>>3]=cadr;
						break;
					}
            gol[(i+m-1)>>3][(j+m-1)>>3]=++cnt;
            gol[(i+m)>>3][(j+m-1)>>3]=cnt;
            gol[(i+m)>>3][(j+m)>>3]=cnt;
            make_tip(C0IMIN,C0JMIN,m,l,c);
            make_tip(C1IMIN,C1JMIN,m,C1IMAX,C1JMAX);
            make_tip(C2IMIN,C2JMIN,m,C2IMIN,C2JMAX);
            make_tip(C3IMIN,C3JMIN,m,C3IMIN,C3JMIN);
            break;
         case 1:
            if(n==8)
					{
                  if(l==Lin && c==Col)tip[i>>3][j>>3]=255;
						else tip[i>>3][j>>3]=cadr;
						break;
					}
            gol[(i+m-1)>>3][(j+m)>>3]=++cnt;
            gol[(i+m)>>3][(j+m)>>3]=cnt;
            gol[(i+m)>>3][(j+m-1)>>3]=cnt;
            make_tip(C0IMIN,C0JMIN,m,C0IMAX,C0JMIN);
            make_tip(C1IMIN,C1JMIN,m,l,c);
            make_tip(C2IMIN,C2JMIN,m,C2IMIN,C2JMAX);
            make_tip(C3IMIN,C3JMIN,m,C3IMIN,C3JMIN);
            break;
         case 2:
         	if(n==8)
					{
                  if(l==Lin && c==Col)tip[i>>3][j>>3]=255;
						else tip[i>>3][j>>3]=cadr;
						break;
					}
            gol[(i+m-1)>>3][(j+m-1)>>3]=++cnt;
            gol[(i+m-1)>>3][(j+m)>>3]=cnt;
            gol[(i+m)>>3][(j+m)>>3]=cnt;
            make_tip(C0IMIN,C0JMIN,m,C0IMAX,C0JMIN);
            make_tip(C1IMIN,C1JMIN,m,C1IMAX,C1JMAX);
            make_tip(C2IMIN,C2JMIN,m,l,c);
            make_tip(C3IMIN,C3JMIN,m,C3IMIN,C3JMIN);
            break;
         case 3:
            if(n==8)
					{
                  if(l==Lin && c==Col)tip[i>>3][j>>3]=255;
						else tip[i>>3][j>>3]=cadr;
						break;
					}
            gol[(i+m-1)>>3][(j+m-1)>>3]=++cnt;
            gol[(i+m-1)>>3][(j+m)>>3]=cnt;
            gol[(i+m)>>3][(j+m-1)>>3]=cnt;
            make_tip(C0IMIN,C0JMIN,m,C0IMAX,C0JMIN);
            make_tip(C1IMIN,C1JMIN,m,C1IMAX,C1JMAX);
            make_tip(C2IMIN,C2JMIN,m,C2IMIN,C2JMAX);
            make_tip(C3IMIN,C3JMIN,m,l,c);
      }
}

int main(void)
{
	int i,j;
	f=fopen(FIN,"rt");fscanf(f,"%d %d %d",&N,&Lin,&Col);fclose(f);
   Lin--;Col--;

   if(N<8)
   	{
      	f=fopen(FOUT,"wt");
         pavare(0,0,N,Lin,Col);
         for(i=0;i<N;i++)
         	{
            	for(j=0;j<N;j++)fprintf(f,"%d ",a[i][j]);
               fprintf(f,"\n");
            }
         fclose(f);
         return 0;
      }

   f=fopen(FOUT,"wb");

   buf=(char far*)farcalloc(BUF_SZ,sizeof(char));

   make_tip(0,0,N,Lin,Col);
   solve();

   if(buf_sz)flush();
   farfree(buf);fclose(f);
   return 0;
}