// Radu Berinde - Bucuresti, Romania

#include <stdio.h>

typedef char num[40];

int P[200], Np;
int N;
num far A[1001], far L[1001];

void copy(char far *B, char far * A)
{
for (int i = 0; i <= A[0]; i++)
B[i] = A[i];
}
char far C[40];
void update(char far *A, int x, char far *B)
{
int i, R = 0;
for (i = 1; i <= A[0]; i++)
{
R += x*A[i];
C[i] = R % 10;
R /= 10;
}
for (C[0] = A[0]; R; R /= 10)
C[++C[0]] = R % 10;
if (C[0] < B[0]) return;
if (C[0] == B[0])
{
for (i = C[0]; i > 0 && C[i] == B[i]; i--);
if (i == 0 || C[i] < B[i]) return;
}
copy(B, C);
}

void belea()
{
int i, j, k;
long x;
A[0][0] = A[0][1] = 1;
for (i = 0; i < Np; i++)
{
for (j = 0; j <= N; j++)
copy(L[j], A[j]);
for (x = P[i]; x <= N; x*=P[i])
for (k = x; k <= N; k++)
update(L[k-x], x, A[k]);
}
for (i = 0; i < N; i++)
update(A[i], 1, A[N]);
}

int prim(int x)
{
int i;
for (i = 2; i*i <= x; i++)
if (x % i == 0) return 0;
return 1;
}

void genprimes()
{
int i;
for (i = 2; i <= N; i++)
if (prim(i)) P[Np++] = i;
}

void print()
{
FILE *fo = fopen("perm.out", "wt");
int i;
for (i = A[N][0]; i > 0; i--)
fprintf(fo, "%d", A[N][i]);
fprintf(fo, "\n");
fclose(fo);
}

void read_data()
{
FILE *fi = fopen("perm.in", "rt");
fscanf(fi, "%d", &N);
fclose(fi);
}

void main()
{
read_data();
genprimes();
belea();
print();
} 
