{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 65000,0,655360}

Program Bombardamente;

const filein='laden.in';
      fileout='laden.out';
      MAXN=5000;
      coseps:real=1e-6;
      deps:real=1e-3;

var fin,fout:text;
    x,y:array[1..MAXN] of real;
    i,j,k,n,p1,p2,p3,q,m,out,laststep,smo:integer;
    xc,yc,xm,ym,r,d,a,b,c,a1,b1,c1,a2,b2,c2,cos1,cos2,cos3:real;

    t2:longint absolute 0:$046c;
    t1:longint;

procedure ReadInput;
begin
assign(fin,filein);
reset(fin);
readln(fin,n);
for i:=1 to n do
  readln(fin,x[i],y[i]);
close(fin);
end;

procedure WriteOutput;
begin
r:=sqrt(r);
assign(fout,fileout);
rewrite(fout);
writeln(fout,trunc(r*100)/100:0:2);
write(fout,trunc(xc*100)/100:0:2);
writeln(fout,' ',trunc(yc*100)/100:0:2);
close(fout);
end;

function AllInside(var pointoutside:integer):boolean;
begin
for i:=1 to n do
  begin
    d:=(x[i]-xc)*(x[i]-xc)+(y[i]-yc)*(y[i]-yc);
    if (d>r) and (abs(d-r)>=deps) then
      begin
        AllInside:=False;
        pointoutside:=i;
        exit;
      end;
  end;
AllInside:=True;
end;

function semn(xx,yy:real):integer;
var re:real;
begin
re:=a*xx+b*yy+c;
if (abs(re)<deps) then semn:=0
else if (re>0) then semn:=1
     else semn:=-1;
end;

procedure Step1;
begin
randomize;
p1:=1; p2:=random(n-1)+2; p3:=0;
end;

procedure Step2;
begin
xc:=(x[p1]+x[p2])/2;
yc:=(y[p1]+y[p2])/2;
r:=(xc-x[p1])*(xc-x[p1])+(yc-y[p1])*(yc-y[p1]);
laststep:=2;
end;

procedure Step3;
begin
a:=(y[p1]-y[p2]);
b:=(x[p2]-x[p1]);
xm:=(x[p1]+x[p2])/2;
ym:=(y[p1]+y[p2])/2;
a1:=b;
b1:=-a;
c1:=a*ym-b*xm;

a:=(y[p1]-y[p3]);
b:=(x[p3]-x[p1]);
xm:=(x[p1]+x[p3])/2;
ym:=(y[p1]+y[p3])/2;
a2:=b;
b2:=-a;
c2:=a*ym-b*xm;

xc:=(b2*c1-b1*c2)/(a2*b1-a1*b2);
yc:=(c2*a1-c1*a2)/(a2*b1-a1*b2);
r:=(xc-x[p1])*(xc-x[p1])+(yc-y[p1])*(yc-y[p1]);
laststep:=3;
end;

procedure Step4;
begin
a:=(x[p1]-x[out])*(x[p1]-x[out])+(y[p1]-y[out])*(y[p1]-y[out]);
b:=(x[p2]-x[out])*(x[p2]-x[out])+(y[p2]-y[out])*(y[p2]-y[out]);
c:=(x[p3]-x[out])*(x[p3]-x[out])+(y[p3]-y[out])*(y[p3]-y[out]);

if (a>=b) and (a>=c) then
  q:=p1
else
if (b>=a) and (b>=c) then
  q:=p2
else
if (c>=a) and (c>=b) then
  q:=p3;

a:=y[q]-yc;
b:=xc-x[q];
c:=x[q]*yc-xc*y[q];

smo:=semn(x[out],y[out]);
if (p1<>q) and (semn(x[p1],y[p1])*smo<=0) then
  m:=p1
else
if (p2<>q) and (semn(x[p2],y[p2])*smo<=0) then
  m:=p2
else
if (p3<>q) and (semn(x[p3],y[p3])*smo<=0) then
  m:=p3;

p1:=q; p2:=out; p3:=m;

laststep:=4;
end;

begin
ReadInput;

Step1;
Step2;

while (not AllInside(out)) do
  begin
    if (laststep=2) then
      p3:=out
    else
      Step4;

    a:=(x[p2]-x[p3])*(x[p2]-x[p3])+(y[p2]-y[p3])*(y[p2]-y[p3]);
    b:=(x[p1]-x[p3])*(x[p1]-x[p3])+(y[p1]-y[p3])*(y[p1]-y[p3]);
    c:=(x[p1]-x[p2])*(x[p1]-x[p2])+(y[p1]-y[p2])*(y[p1]-y[p2]);

    cos1:=(b+c-a)/(2*sqrt(b*c));
    cos2:=(a+c-b)/(2*sqrt(a*c));
    cos3:=(a+b-c)/(2*sqrt(a*b));

    if (cos1<0) or (abs(cos1)<coseps) then
      begin
        p1:=p2; p2:=p3;
        Step2;
      end
    else
    if (cos2<0) or (abs(cos2)<coseps) then
      begin
        p1:=p1; p2:=p3;
        Step2;
      end
    else
    if (cos3<0) or (abs(cos3)<coseps) then
      begin
        p1:=p1; p2:=p2;
        Step2;
      end
    else
      Step3;
  end;

WriteOutput;
end.