{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{ 
Preprocesare: O(N^2 * logN)
Update: O((logN)^2)
}

{$S-,I-,R-,Q-,N+}
{$M 65000,0,655360}
Program BURSA;

const filein='BURSA.IN';
      fileout='BURSA.OUT';
      MAXN=210;
      MAXL=15;

type col=array[1..MAXN] of longint;
     pcol=^col;
     buffer=array[1..65000] of char;
     pbuffer=^buffer;
     list=array[1..MAXL] of byte;
     plist=^list;

var fin,fout:text;
    plan:array[1..MAXN] of pcol;
    tata,li,ls:array[1..MAXN] of integer;
    fiu:array[1..MAXN,1..2] of integer;
    lpoz:array[1..(MAXN shr 1),1..(MAXN shr 1)] of plist;
    npoz:array[1..(MAXN shr 1),1..(MAXN shr 1)] of byte;
    i,j,k,ii,jj,m,n,size,lins,cols,lind,cold,x,last,pozc,min:longint;
    buf:pbuffer;
{
    t2:longint absolute 0:$046c;
    t1:longint;
}
procedure ReadInput;
begin
new(buf);
fillchar(buf^,sizeof(buffer),0);
assign(fin,filein);
settextbuf(fin,buf^,sizeof(buffer));
reset(fin);
readln(fin,n,m);
end;

procedure WriteOutput;
begin
close(fin);
fillchar(buf^,sizeof(buffer),0);
assign(fout,fileout);
settextbuf(fout,buf^,sizeof(buffer));
rewrite(fout);

for i:=1 to n do
  begin
    for j:=1 to n do
      begin
        if (j>1) then
          write(fout,' ');

        x:=100;

        jj:=j;
        while (jj>0) do
          begin
            ii:=i;
            while (ii>0) do
              begin
                x:=x+plan[jj]^[ii];
                ii:=tata[ii];
              end;

            jj:=tata[jj];
          end;

        write(fout,x);
      end;
    writeln(fout);
  end;
close(fout);
end;

procedure MakeMatrix;
begin
fillchar(tata,sizeof(tata),0);
fillchar(li,sizeof(li),0);
fillchar(ls,sizeof(ls),0);

last:=0;
for i:=1 to n do
  begin
    fiu[i,1]:=0; fiu[i,2]:=0;
    li[i]:=i; ls[i]:=i;
  end;
k:=n;

while (k>1) do
  begin
    j:=last+k; k:=0;
    for i:=last+1 to j do
      if ((i-last) and 1=1) then
        begin
          if (i+1<=j) then
            begin
              inc(k);
              tata[i]:=j+k;
              tata[i+1]:=j+k;
              li[j+k]:=li[i];
              ls[j+k]:=ls[i+1];
              fiu[j+k,1]:=i;
              fiu[j+k,2]:=i+1;
            end
          else
            begin
              inc(k);
              tata[i]:=j+k;
              li[j+k]:=li[i];
              ls[j+k]:=ls[i];
              fiu[j+k,1]:=i;
              fiu[j+k,2]:=0;
            end;
        end;
    last:=j;
  end;

size:=last+k;

for i:=1 to size do
  begin
    new(plan[i]);
    fillchar(plan[i]^,sizeof(col),0);
  end;
end;

procedure insertseg(num,n1,n2:integer);
var i,j,p:integer;
begin
if (n1=li[num]) and (n2=ls[num]) then
  begin
    inc(npoz[ii,jj]);
    lpoz[ii,jj]^[npoz[ii,jj]]:=num;
  end
else
  begin
    i:=fiu[num,1];
    j:=fiu[num,2];

    if (j=0) then
      insertseg(i,n1,n2)
    else
      begin
        p:=ls[i];
        if (n1<=p) then
          begin
            if (n2<=p) then
              insertseg(i,n1,n2)
            else
              begin
                insertseg(i,n1,p);
                insertseg(j,p+1,n2);
              end;
          end
        else
          insertseg(j,n1,n2);
      end;

  end;
end;

procedure PrecomputePositions;
begin
fillchar(npoz,sizeof(npoz),0);

min:=0;
for ii:=1 to n do
  for jj:=ii to n do
    begin
      new(lpoz[ii,jj]);
      fillchar(lpoz[ii,jj]^,sizeof(list),0);
      insertseg(size,ii,jj);

      if (npoz[ii,jj]>min) then
        min:=npoz[ii,jj];
    end;
end;

begin
{
t1:=t2;
}
ReadInput;
MakeMatrix;
PrecomputePositions;

for k:=1 to m do
  begin
    readln(fin,lins,cols,lind,cold,x);

    ii:=npoz[lins,lind];
    jj:=npoz[cols,cold];
    for i:=1 to ii do
      for j:=1 to jj do
        inc(plan[lpoz[cols,cold]^[j]]^[lpoz[lins,lind]^[i]],x);
  end;

WriteOutput;
{
writeln(t2-t1);
}
end.