{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 64000,0,655360}
Program ADEVAR;

const filein='ADEVAR.IN';
      fileout='ADEVAR.OUT';
      MAXN=12;
      pow2:array[0..MAXN] of longint=
      (1,2,4,8,16,32,64,128,256,512,1024,2048,4096);
      pow3:array[0..MAXN-1] of longint=
      (1,3,9,27,81,243,729,2187,6561,19683,59049,177147);
      lit:array[0..MAXN-1] of char=
      ('A','B','C','D','E','F','G','H','I','J','K','L');

type plist=^list;
     list=record
            nr:longint;
            urm:plist;
            okk:boolean;
          end;

var fin,fout:text;
    table:array[0..5000] of integer;
    i,j,k,m,n,v,vn,p,q,cat,rest,cat8,rest8,nmt,nmc,nt,nok,miss,plus:longint;
    aux,ant,expr,last:plist;
    found,corect:boolean;
    vnum,stack,vv:array[-1..MAXN] of integer;
{
    t2:longint absolute 0:$046c;
    t1:longint;
}
procedure findparents(level:byte);
begin
if (level=n) then
  begin
    if (table[vn]=1) then
      inc(plus)
    else
      begin
        plus:=-1000000;
        nmc:=nmc+1000000;
      end
  end
else
  begin
    if (vnum[level]=0) then
      begin
        if (nmc<nmt) then
          findparents(level+1)
      end
    else
    if (vnum[level]=1) then
      begin
        vn:=vn+pow2[level];
        if (nmc<nmt) then
          findparents(level+1);
        vn:=vn-pow2[level];
      end
    else
      begin
        if (nmc<nmt) then
          findparents(level+1);

        vn:=vn+pow2[level];

        if (nmc<nmt) then
          findparents(level+1);
        vn:=vn-pow2[level];
      end;
  end;
end;

procedure markparents(level:byte);
begin
if (level=n) then
  begin
    inc(table[vn]);
  end
else
  begin
    if (vnum[level]=0) then
      markparents(level+1)
    else
    if (vnum[level]=1) then
      begin
        vn:=vn+pow2[level];
        markparents(level+1);
        vn:=vn-pow2[level];
      end
    else
      begin
        markparents(level+1);

        vn:=vn+pow2[level];
        markparents(level+1);
        vn:=vn-pow2[level];
      end;
  end;
end;

procedure back2(niv:byte);
begin
if (niv=n) then
  begin
        fillchar(vv,sizeof(vv),0);
        vn:=0;

        plus:=0;
        findparents(0);

        if (plus>0) then
          begin
            nmc:=nmc+plus;
            markparents(0);

            if (expr=nil) then
              begin
                new(expr);
                expr^.nr:=v;
                expr^.urm:=nil;
                last:=expr;
              end
            else
              begin
                new(aux);
                aux^.nr:=v;
                aux^.urm:=nil;
                last^.urm:=aux;
                last:=aux;
              end;
            inc(nt);
          end
        else
          nmc:=nmc-1000000;
  end
else
  begin
    if (vnum[niv]=2) then
      begin
        v:=v+pow3[niv]*2;

        if (nmc<nmt) then
          back2(niv+1);

        v:=v-pow3[niv]*2;
      end
    else
      begin
        vnum[niv]:=1;
        v:=v+pow3[niv];

        if (nmc<nmt) then
          back2(niv+1);

        v:=v-pow3[niv];

        vnum[niv]:=0;

        if (nmc<nmt) then
          back2(niv+1);
      end;
  end;
end;

procedure generatemissingterms2(nivel:byte);
var s1:byte;
begin
if (nivel=miss) then
  begin
    v:=0;
    back2(0);
  end
else
  begin
    for s1:=stack[nivel-1]+1 to n-miss+nivel do
      begin
        stack[nivel]:=s1;
        vnum[s1]:=2;
        generatemissingterms2(nivel+1);
        vnum[s1]:=0;
      end;
  end;
end;

begin
{
t1:=t2;
}
assign(fin,filein);
reset(fin);
readln(fin,n);

nmt:=0;
for i:=0 to pow2[n]-1 do
  begin
    readln(fin,table[i]);
    nmt:=nmt+table[i];
  end;
close(fin);

{ Find the terms of the sum }
nmc:=0;
expr:=nil;
nt:=0;
stack[-1]:=-1;
for k:=1 to n do
  begin
    miss:=n-k;
    fillchar(vnum,sizeof(vnum),0);
    generatemissingterms2(0);

    if (nmc=nmt) then break;
  end;

{ Print the terms }
assign(fout,fileout);
rewrite(fout);
while (expr<>nil) do
  begin
    v:=expr^.nr;
    for p:=n-1 downto 0 do
      begin
        q:=(v div pow3[p]) mod 3;

        if (q=1) then
          write(fout,lit[n-p-1])
        else
        if (q=0) then
          write(fout,'_',lit[n-p-1]);
      end;

    if (nt>1) then
      write(fout,'+');

    aux:=expr;
    expr:=expr^.urm;
    dispose(aux);
    dec(nt);
  end;
close(fout);
{
writeln(t2-t1);
}
end.