#include <stdio.h>

int H[52][52], Si, Sj, Fi, Fj;
int V[52][52], N;

struct entry
{
int i, j;
} coada[2505];

int cl, cr;
int veci[4] = {0, 0, -1, 1};
int vecj[4] = {1, -1, 0, 0};

#define ni (i+veci[v])
#define nj (j+vecj[v])

int incearca(int sp)
{
int i, j, v;
for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
V[i][j] = 0;
V[Fi][Fj] = -1;
V[Si][Sj] = sp;
coada[0].i = Si;
coada[0].j = Sj;
for (cl = cr = 0; cl <= cr; cl++)
{
i = coada[cl].i;
j = coada[cl].j;
for (v = 0; v < 4; v++)
if (V[i][j]+H[i][j]-H[ni][nj]-1 > V[ni][nj])
{

V[ni][nj] = V[i][j]+H[i][j]-H[ni][nj]-1;
coada[++cr].i = ni;
coada[cr].j = nj;
}
}
return V[Fi][Fj] >= 0;
}

int solve()
{
int vl, vr, vm;
if (Si == Fi && Sj == Fj) return 0;
for (vl = 1, vr = 4000; vl < vr;)
{
vm = (vl+vr)/2;
if (incearca(vm))
vr = vm;
else
vl = vm+1;
}
return vl;
}


void print(int r)
{
FILE *fo = fopen("munte.out", "wt");
fprintf(fo, "%d\n", r);
fclose(fo);
}

void read_data()
{
int i, j;
FILE *fi = fopen("munte.in", "rt");
fscanf(fi, "%d %d %d %d %d", &N, &Si, &Sj, &Fi, &Fj);
for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
fscanf(fi, "%d", H[i]+j);
for (i = 0; i <= N+1; i++)
H[0][i] = H[i][0] = H[N+1][i] = H[i][N+1] = 6666;
fclose(fi);
}

void main()
{
read_data();
print(solve());
}