#include <stdio.h>

int A[102][102], H[102][102], N, R;

struct punct
{
char i, j;
} far heap[10010];

int hs;

punct _t;
#define comp(a, b) (H[heap[a].i][heap[a].j] > H[heap[b].i][heap[b].j])
#define fiu(i) (2*i >= hs || comp(2*i, 2*i+1) ? 2*i : 2*i+1)
#define swap(a, b) (_t = heap[a], heap[a] = heap[b], heap[b] = _t)

void sift(int i)
{
for (int p; i <= hs/2 && ((p = fiu(i)) != 1) && comp(p, i); i = p)
swap(i, p);
}

void sort()
{
int i, j;
for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
{
heap[(i-1)*N+j].i = i;
heap[(i-1)*N+j].j = j;
}
hs = N*N;
for (i = N*N/2; i > 0; i--)
sift(i);
for (; hs; hs--, sift(1))
swap(1, hs);
}

int vi[4] = {0, 0, 1, -1},
vj[4] = {1, -1, 0, 0};

#define ni (i+vi[v])
#define nj (j+vj[v])
void solve()
{
int i, j, l, v;
sort();
for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
A[i][j] = 1;
for (l = 1; l <= N*N; l++)
{
i = heap[l].i;
j = heap[l].j;
for (v = 0; v < 4; v++)
if (H[ni][nj] < H[i][j] && A[ni][nj] >= A[i][j])
A[i][j] = A[ni][nj]+1;
}
for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
if (A[i][j] > R) R = A[i][j];
}

void print()
{
FILE *fo = fopen("sus.out", "wt");
fprintf(fo, "%d\n", R-1);
fclose(fo);
}

void read_data()
{
FILE *fi = fopen("sus.in", "rt");
int i, j;
fscanf(fi, "%d", &N);
for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
fscanf(fi, "%d", H[i]+j);
fclose(fi);
}


void main()
{
read_data();
solve();
print();
}
 