{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 64000,0,655360}
Program ADEVAR;

const filein='ADEVAR.IN';
      fileout='ADEVAR.OUT';
      MAXN=12;
      pow2:array[0..MAXN] of longint=
      (1,2,4,8,16,32,64,128,256,512,1024,2048,4096);
      pow3:array[0..MAXN-1] of longint=
      (1,3,9,27,81,243,729,2187,6561,19683,59049,177147);
      lit:array[0..MAXN-1] of char=
      ('A','B','C','D','E','F','G','H','I','J','K','L');

type plist=^list;
     list=record
            nr:longint;
            urm:plist;
            okk:boolean;
          end;
     line=array[0..66] of byte;
     pline=^line;

var fin,fout:text;
    table:array[0..5000] of integer;
    ok:array[0..1023] of pline;
    i,j,k,m,n,v,vn,p,q,cat,rest,cat8,rest8,nmt,nmc,nt,nok,miss,plus:longint;
    mcat8,mrest8,mcat,mrest:longint;
    aux,ant,expr,last:plist;
    found,corect:boolean;
    vnum,stack,vv:array[-1..MAXN] of integer;
{
    t2:longint absolute 0:$046c;
    t1:longint;
}
procedure back(niv:byte);
begin
if (niv=n) then
  begin
    cat8:=v shr 3;
    rest8:=v and 7;
    cat:=cat8 shr 10;
    rest:=cat8 and 1023;

    if (ok[rest]^[cat] and pow2[rest8]>0) then
      begin

        for p:=0 to n-1 do
          begin
            q:=(v div pow3[p]) mod 3;
              if (q<2) then
                  begin
                    m:=v+(1-2*q)*pow3[p];
                    mcat8:=m shr 3;
                    mrest8:=m and 7;
                    mcat:=mcat8 shr 10;
                    mrest:=mcat8 and 1023;

                    if (ok[mrest]^[mcat] and pow2[mrest8]>0) then
                      begin
                        vn:=v+(2-q)*pow3[p];

                        cat8:=vn shr 3;
                        rest8:=vn and 7;
                        cat:=cat8 shr 10;
                        rest:=cat8 and 1023;

                        ok[rest]^[cat]:=ok[rest]^[cat] or pow2[rest8];
                      end;
                  end;
          end;
      end;
  end
else
  begin
    if (vnum[niv]=2) then
      begin
        v:=v+pow3[niv]*2;
        back(niv+1);
        v:=v-pow3[niv]*2;
      end
    else
      begin
        vnum[niv]:=0;
        back(niv+1);

        vnum[niv]:=1;
        v:=v+pow3[niv];
        back(niv+1);
        vnum[niv]:=0;
        v:=v-pow3[niv];
      end;
  end;
end;

procedure generatemissingterms(nivel:byte);
var s1:byte;
begin
if (nivel=miss) then
  begin
    v:=0;
    back(0);
  end
else
  begin
    for s1:=stack[nivel-1]+1 to n-miss+nivel do
      begin
        stack[nivel]:=s1;
        vnum[s1]:=2;
        generatemissingterms(nivel+1);
        vnum[s1]:=0;
      end;
  end;
end;

procedure findparents(level:byte);
begin
if (level=n) then
  begin
    if (table[vn]=1) then
      inc(plus);
  end
else
  begin
    if (vnum[level]=0) then
      findparents(level+1)
    else
    if (vnum[level]=1) then
      begin
        vn:=vn+pow2[level];
        findparents(level+1);
        vn:=vn-pow2[level];
      end
    else
      begin
        findparents(level+1);

        vn:=vn+pow2[level];
        findparents(level+1);
        vn:=vn-pow2[level];
      end;
  end;
end;

procedure checkparents(level:byte);
begin
if (level=n) then
  begin
    if (table[vn]=2) then
      inc(plus);
  end
else
  begin
    if (vnum[level]=0) then
      checkparents(level+1)
    else
    if (vnum[level]=1) then
      begin
        vn:=vn+pow2[level];
        checkparents(level+1);
        vn:=vn-pow2[level];
      end
    else
      begin
        checkparents(level+1);

        vn:=vn+pow2[level];
        checkparents(level+1);
        vn:=vn-pow2[level];
      end;
  end;
end;

procedure markparents(level:byte);
begin
if (level=n) then
  begin
    inc(table[vn]);
  end
else
  begin
    if (vnum[level]=0) then
      markparents(level+1)
    else
    if (vnum[level]=1) then
      begin
        vn:=vn+pow2[level];
        markparents(level+1);
        vn:=vn-pow2[level];
      end
    else
      begin
        markparents(level+1);

        vn:=vn+pow2[level];
        markparents(level+1);
        vn:=vn-pow2[level];
      end;
  end;
end;

procedure unmarkparents(level:byte);
begin
if (level=n) then
  begin
    dec(table[vn]);
  end
else
  begin
    if (vnum[level]=0) then
      unmarkparents(level+1)
    else
    if (vnum[level]=1) then
      begin
        vn:=vn+pow2[level];
        unmarkparents(level+1);
        vn:=vn-pow2[level];
      end
    else
      begin
        unmarkparents(level+1);

        vn:=vn+pow2[level];
        unmarkparents(level+1);
        vn:=vn-pow2[level];
      end;
  end;
end;

procedure back2(niv:byte);
begin
if (niv=n) then
  begin
    cat8:=v shr 3;
    rest8:=v and 7;
    cat:=cat8 shr 10;
    rest:=cat8 and 1023;

    if (ok[rest]^[cat] and pow2[rest8]>0) and (nmc<nmt) then
      begin
        fillchar(vv,sizeof(vv),0);
        vn:=0;

        plus:=0;
        findparents(0);
        nmc:=nmc+plus;

        if (plus>0) then
          begin
            markparents(0);

            if (expr=nil) then
              begin
                new(expr);
                expr^.nr:=v;
                expr^.urm:=nil;
                last:=expr;
              end
            else
              begin
                new(aux);
                aux^.nr:=v;
                aux^.urm:=nil;
                last^.urm:=aux;
                last:=aux;
              end;
            inc(nt);
          end;
      end;
  end
else
  begin
    if (vnum[niv]=2) then
      begin
        v:=v+pow3[niv]*2;

        if (nmc<nmt) then
          back2(niv+1);

        v:=v-pow3[niv]*2;
      end
    else
      begin
        vnum[niv]:=1;
        v:=v+pow3[niv];

        if (nmc<nmt) then
          back2(niv+1);

        v:=v-pow3[niv];

        vnum[niv]:=0;

        if (nmc<nmt) then
          back2(niv+1);
      end;
  end;
end;

procedure generatemissingterms2(nivel:byte);
var s1:byte;
begin
if (nivel=miss) then
  begin
    v:=0;
    back2(0);
  end
else
  begin
    for s1:=stack[nivel-1]+1 to n-miss+nivel do
      begin
        stack[nivel]:=s1;
        vnum[s1]:=2;
        generatemissingterms2(nivel+1);
        vnum[s1]:=0;
      end;
  end;
end;

begin
{
t1:=t2;
}
assign(fin,filein);
reset(fin);
readln(fin,n);
for i:=0 to pow2[n]-1 do
  readln(fin,table[i]);
close(fin);

{ Init OK Table }
for i:=0 to 1023 do
  begin
    new(ok[i]);
    fillchar(ok[i]^,sizeof(line),0);
  end;

for i:=0 to pow2[n]-1 do
  if (table[i]=1) then
    begin
      inc(nmt);

      v:=0;
      for j:=0 to n-1 do
        if (i and pow2[j]>0) then
          v:=v+pow3[j];

      cat8:=v shr 3;
      rest8:=v and 7;
      cat:=cat8 shr 10;
      rest:=cat8 and 1023;

      ok[rest]^[cat]:=ok[rest]^[cat] or pow2[rest8];
    end;

{ Compute OK Table }
stack[-1]:=-1;
for k:=n downto 2 do
  begin
    miss:=n-k;
    fillchar(vnum,sizeof(vnum),0);
    generatemissingterms(0);
  end;

{ Find the terms of the sum }
nmc:=0;
expr:=nil;
nt:=0;
for k:=1 to n do
  begin
    miss:=n-k;
    fillchar(vnum,sizeof(vnum),0);
    generatemissingterms2(0);

    if (nmc=nmt) then break;
  end;

{ Cut out the redundant terms }
repeat
  corect:=true;
  ant:=nil;
  aux:=expr;
  while (aux<>nil) do
    begin
      v:=aux^.nr;

      for p:=n-1 downto 0 do
        vnum[p]:=(v div pow3[p]) mod 3;

      vn:=0; plus:=0;
      checkparents(0);

      if (plus=0) then
        begin
          corect:=false;
          dec(nt);

          if (ant=nil) then
            begin
              expr:=expr^.urm;
              dispose(aux);

              aux:=expr;

            end
          else
            begin
              ant^.urm:=aux^.urm;
              dispose(aux);

              aux:=ant^.urm;

            end;

          vn:=0;
          unmarkparents(0);
        end;

      ant:=aux;
      aux:=aux^.urm
    end;

until (corect);

{ Print the terms }
assign(fout,fileout);
rewrite(fout);
while (expr<>nil) do
  begin
    v:=expr^.nr;
    for p:=n-1 downto 0 do
      begin
        q:=(v div pow3[p]) mod 3;

        if (q=1) then
          write(fout,lit[n-p-1])
        else
        if (q=0) then
          write(fout,'_',lit[n-p-1]);
      end;

    if (nt>1) then
      write(fout,'+');

    aux:=expr;
    expr:=expr^.urm;
    dispose(aux);
    dec(nt);
  end;
close(fout);

{
writeln(t2-t1);
}
end.