{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 32000,0,655360}
Program ADEVAR;

const filein='ADEVAR.IN';
      fileout='ADEVAR.OUT';
      MAXN=12;
      pow2:array[0..MAXN] of longint=
      (1,2,4,8,16,32,64,128,256,512,1024,2048,8192);
      pow3:array[0..MAXN-1] of longint=
      (1,3,9,27,81,243,729,2187,6561,19683,59049,177147);
      lit:array[0..MAXN-1] of char=
      ('A','B','C','D','E','F','G','H','I','J','K','L');
      prim=1003;


type plist=^list;
     list=record
            nr:longint;
            urm:plist;
          end;

var fin,fout:text;
    table:array[0..8191] of byte;
    hash:array[0..prim-1,1..MAXN] of plist;
    i,j,k,m,n,v,vn,p,q,nmt,nmc,nt,nok:longint;
    aux,aux1,expr,last,eaux:plist;
    found:boolean;
    vnum,stack:array[0..MAXN] of longint;

procedure back(niv:byte);
begin
if (niv=n) then
  begin
    vn:=0;
    for p:=0 to n-1 do
      vn:=vn+stack[p]*pow2[p];

    if (table[vn]=1) then
      begin
        table[vn]:=2;
        inc(nok);
      end;
  end
else
  begin
    if (vnum[niv]<2) then
      begin
        stack[niv]:=vnum[niv];
        back(niv+1);
      end
    else
      begin
        stack[niv]:=1;
        back(niv+1);
        stack[niv]:=0;
        back(niv+1);
      end;
  end;
end;

begin
assign(fin,filein);
reset(fin);
readln(fin,n);
for i:=0 to pow2[n]-1 do
  readln(fin,table[i]);
close(fin);

fillchar(hash,sizeof(hash),0);
nmt:=0;
for i:=0 to pow2[n]-1 do
  if (table[i]=1) then
    begin
      inc(nmt);

      v:=0;
      for j:=0 to n-1 do
        if (i and pow2[j]>0) then
          v:=v+pow3[j];

      j:=v mod prim;
      new(aux);
      aux^.nr:=v;
      aux^.urm:=hash[j,n];
      hash[j,n]:=aux;
    end;

for k:=n downto 2 do
  begin
    for i:=0 to prim-1 do
      begin
        aux:=hash[i,k];
        while (aux<>nil) do
          begin
            v:=aux^.nr;
            for p:=0 to n-1 do
              begin
                q:=(v div pow3[p]) mod 3;
                if (q<2) then
                  begin
                    m:=v+(1-2*q)*pow3[p];
                    j:=m mod prim;

                    aux1:=hash[j,k];
                    found:=false;
                    while (aux1<>nil) do
                      begin
                        if (aux1^.nr=m) then
                          begin
                            found:=true;
                            break;
                          end
                        else
                          aux1:=aux1^.urm;
                      end;

                    if (found) then
                      begin
                        vn:=v+(2-q)*pow3[p];
                        j:=vn mod prim;

                        aux1:=hash[j,k-1];
                        found:=false;
                        while (aux1<>nil) do
                          begin
                            if (aux1^.nr=vn) then
                              begin
                                found:=true;
                                break;
                              end
                            else
                              aux1:=aux1^.urm;
                          end;

                        if (not found) then
                          begin
                            new(aux1);
                            aux1^.nr:=vn;
                            aux1^.urm:=hash[j,k-1];
                            hash[j,k-1]:=aux1;
                          end;
                      end;
                  end;
              end;

            aux:=aux^.urm;
          end;
      end;
  end;

nmc:=0;
expr:=nil;
nt:=0;
for k:=1 to n do
  begin
    for i:=0 to prim-1 do
      begin
        aux:=hash[i,k];
        while (aux<>nil) do
          begin
            v:=aux^.nr;
            for p:=0 to n-1 do
              vnum[p]:=(v div pow3[p]) mod 3;

            nok:=0;
            back(0);

            inc(nmc,nok);

            if (nok>0) then
              begin
                inc(nt);
                new(aux1);
                aux1^.nr:=v;
                aux1^.urm:=nil;

                if (expr=nil) then
                  begin
                    expr:=aux1;
                    last:=expr;
                  end
                else
                  begin
                    last^.urm:=aux1;
                    last:=aux1;
                  end;
              end;

            if (nmc=nmt) then break;
            aux:=aux^.urm;
          end;

        if (nmc=nmt) then break;
      end;

    if (nmc=nmt) then break;
  end;

assign(fout,fileout);
rewrite(fout);
while (expr<>nil) do
  begin
    v:=expr^.nr;
    for p:=n-1 downto 0 do
      begin
        q:=(v div pow3[p]) mod 3;

        if (q=1) then
          write(fout,lit[n-p-1])
        else
        if (q=0) then
          write(fout,'_',lit[n-p-1]);
      end;

    if (nt>1) then
      write(fout,'+');

    aux:=expr;
    expr:=expr^.urm;
    dispose(aux);
    dec(nt);
  end;
writeln(fout);
close(fout);
end.