{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-}
{$M 65000,0,655360}
Program SUS;

const filein='sus.in';
      fileout='sus.out';
      MAXN=101;
      dr:array[1..4] of integer=(-1,0,+1,0);
      dc:array[1..4] of integer=(0,+1,0,-1);

type intarray=array[1..MAXN*MAXN] of integer;
     bytearray=array[1..MAXN*MAXN] of byte;
     intmatrix=array[1..MAXN,1..MAXN] of integer;

var fin,fout:text;
    maxpath,hei:intmatrix;
    row,column:bytearray;
    i,j,i1,j1,k,m,n,np,q:integer;
    haux,height:^intarray;
    raux,caux:^bytearray;

procedure sort(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (height^[li]>height^[ls]) then
      begin
        k:=height^[li]; height^[li]:=height^[ls]; height^[ls]:=k;
        k:=row[li]; row[li]:=row[ls]; row[ls]:=k;
        k:=column[li]; column[li]:=column[ls]; column[ls]:=k;
      end;
  end
else
if (ls-li>1) then
  begin
    sort(li,(li+ls) shr 1);
    sort(((li+ls) shr 1)+1,ls);

    k:=li-1;
    i:=li;
    m:=(li+ls) shr 1;
    j:=m+1;

    while (i<=m) and (j<=ls) do
      begin
        inc(k);
        if (height^[i]<height^[j]) then
          begin
            haux^[k]:=height^[i];
            raux^[k]:=row[i];
            caux^[k]:=column[i];
            inc(i);
          end
        else
          begin
            haux^[k]:=height^[j];
            raux^[k]:=row[j];
            caux^[k]:=column[j];
            inc(j);
          end;
      end;

    if (i<=m) then
      begin
        for j:=i to m do
          begin
            inc(k);
            haux^[k]:=height^[j];
            raux^[k]:=row[j];
            caux^[k]:=column[j];
          end;
      end
    else
      begin
        for i:=j to ls do
          begin
            inc(k);
            haux^[k]:=height^[i];
            raux^[k]:=row[i];
            caux^[k]:=column[i];
          end;
      end;

    for k:=li to ls do
      begin
        height^[k]:=haux^[k];
        row[k]:=raux^[k];
        column[k]:=caux^[k];
      end;
  end;
end;

begin
assign(fin,filein);
reset(fin);
readln(fin,n);
np:=0;

new(height);
for i:=1 to n do
  begin
    for j:=1 to n do
      begin
        read(fin,m);
        hei[i,j]:=m;
        inc(np);
        height^[np]:=m;
        row[np]:=i;
        column[np]:=j;
      end;
  end;
close(fin);

new(haux);
new(raux);
new(caux);
sort(1,np);
dispose(haux);
dispose(raux);
dispose(caux);

fillchar(maxpath,sizeof(maxpath),0);
m:=0;

for k:=1 to np do
  begin
    i:=row[k]; j:=column[k];
    for q:=1 to 4 do
      begin
        i1:=i+dr[q];
        j1:=j+dc[q];

        if (i1>0) and (i1<=n) and
           (j1>0) and (j1<=n) and
           (hei[i1,j1]<hei[i,j]) and
           ((maxpath[i1,j1]+1)>maxpath[i,j]) then
           maxpath[i,j]:=maxpath[i1,j1]+1;
      end;

    if (maxpath[i,j]>m) then
      m:=maxpath[i,j];
  end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,m);
close(fout);
end.